- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes

# ComponentUI Class Reference

Search for all occurrences

## Detailed Description

This class represents the user interface which belongs to a component in map extraction.

By design, there are no other UI elements on the map extraction dialog other than the component panel. This means that common widgets which belongs to all the components (for example layout related widgets, texture size) must be included in all the component panels. There are functions in this class which makes it very easy for the component to create these widgets, so that their look is preserved between the different components. This also gives a chance for the components to customize these widgets, for example if a component doesn't need the level for the target meshes, it can get a widget which hides the level of the target meshes. When the user opens the properties window for a map extractor node, the UserInterface is called in all the components. Those functions must create a new instance of a class inherited from ComponentUI, which will then used to communicate with the user. Only one of these panels are shown at a time, the others are hiden. When the user switches components, the previous panel is hidden, and another one is shown.

Definition at line 230 of file MapExtractorInterface.h.

`#include <MapExtractorInterface.h>`

Inheritance diagram for ComponentUI:
[legend]

List of all members.

## Public Member Functions
virtual void | Initialize (void)
virtual QWidget * | RootWidget (void)
virtual void | UpdateValues (void)
QLabel * | SmallerLabel (const QString &text)
## Public Attributes
TextureExtractionDialog * | m_pDialog
Mapper * | m_pMapper
bool | m_bValidData
bool | m_bDefaultTargetToLowestLevel
class Component * | m_pTarget
## Protected Member Functions
| ComponentUI (class Component *pTarget)
QWidget * | CreateTargetWidget (bool bSmoothing=true, bool bUVSmoothing=true, bool bDefaultToLowest=true, bool bShowLevels=true)
| This function creates a widget which represents the list of the target meshes, including the smoothing checboxes.
QWidget * | CreateSourceWidget (bool bSmoothing=true)
| This function creates a widget which is used for the source mesh list, including the checkbox for smooth surface.
QWidget * | CreateLocatorWidget (void)
| This function creates the widget which contains the parameters of the current locator node.
QWidget * | CreateLayoutWidget (void)
| This function creates the widget which contains the parameters of the current locator node.
QWidget * | CreateOutputWidget (void)
| This function creates a widget where the user can set output related settings, like filename and extension (the extension controls the type of the utilizers, so when the user chooses a different extension, the utilizer and layout object might be recreated)
## Protected Attributes
QComboBox * | m_pLocateMethod

## Constructor & Destructor Documentation

ComponentUI | ( | class Component * | pTarget | ) | `[protected]`

## Member Function Documentation

QWidget* CreateTargetWidget | ( | bool | bSmoothing = `true`,
|  | bool | bUVSmoothing = `true`,
|  | bool | bDefaultToLowest = `true`,
|  | bool | bShowLevels = `true`
| ) |  | `[protected]`

Search for all occurrences

This function creates a widget which represents the list of the target meshes, including the smoothing checboxes.

Parameters:

  [in] | bSmoothing | if true, the smoothing checkbox will be visible.
  [in] | bUVSmoothing | if true, the texture coordinate smoothing checkbox will be visible.
  [in] | bDefaultToLowest | if true, and the user adds a new mesh as the target, the lowest level of that mesh will be used by default.
  [in] | bShowLevels | if true, the level column will be visible to the user, letting them choose the subdivision level.

QWidget* CreateSourceWidget | ( | bool | bSmoothing = `true` | ) | `[protected]`

Search for all occurrences

This function creates a widget which is used for the source mesh list, including the checkbox for smooth surface.

Parameters:

  [in] | bSmoothing | if true, the smoothing checkbox will be visible.

QWidget* CreateLocatorWidget | ( | void |  | ) | `[protected]`

Search for all occurrences

This function creates the widget which contains the parameters of the current locator node.

The look of this widget depends on the type of the locator.

QWidget* CreateLayoutWidget | ( | void |  | ) | `[protected]`

Search for all occurrences

This function creates the widget which contains the parameters of the current locator node.

The look of this widget depends on the type of the locator. For example for traditional texture map extraction this widget is where the user can alter the size of the extracted texture.

QWidget* CreateOutputWidget | ( | void |  | ) | `[protected]`

Search for all occurrences

This function creates a widget where the user can set output related settings, like filename and extension (the extension controls the type of the utilizers, so when the user chooses a different extension, the utilizer and layout object might be recreated)

virtual void Initialize | ( | void |  | ) | `[virtual]`

Search for all occurrences

Reimplemented from Node.

virtual QWidget* RootWidget | ( | void |  | ) | `[virtual]`

Search for all occurrences

virtual void UpdateValues | ( | void |  | ) | `[virtual]`

Search for all occurrences

QLabel* SmallerLabel | ( | const QString & | text | ) |

Search for all occurrences

## Member Data Documentation

TextureExtractionDialog* m_pDialog

Search for all occurrences

Definition at line 262 of file MapExtractorInterface.h.

Mapper* m_pMapper

Search for all occurrences

Definition at line 263 of file MapExtractorInterface.h.

bool m_bValidData

Search for all occurrences

Definition at line 264 of file MapExtractorInterface.h.

bool m_bDefaultTargetToLowestLevel

Search for all occurrences

Definition at line 265 of file MapExtractorInterface.h.

class Component* m_pTarget

Search for all occurrences

Definition at line 266 of file MapExtractorInterface.h.

QComboBox* m_pLocateMethod `[protected]`

Search for all occurrences

Definition at line 284 of file MapExtractorInterface.h.

The documentation for this class was generated from the following file:

- MapExtractor/MapExtractorInterface.h

ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI
ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI ComponentUI